//*************************************************************************************
// Reverse Script.mq4
// Aug 1, 2006
//*************************************************************************************
#property copyright "Professional Micro Systems Inc."

extern int     Slippage   = 3;
extern int     TakeProfit = 0;

int start()
   {
   int     i            = 0;    
   int     CountOrders  = 0;
   double  NumberLots   = 0;    
   int     TicketNumber = 0;    

   //
   //  Count the number of open positions for this symbol
   //
   for ( i=0; i<OrdersTotal(); i++ ) // pass through orders
      {
      Alert(i+1," of ",OrdersTotal(),", symbol=",OrderSymbol(),", type=",OrderType());
      if ( OrderSelect ( CountOrders, SELECT_BY_POS, MODE_TRADES ) ) // if the order is chosen successfully
         if ( OrderSymbol() != Symbol() || ( OrderType() != OP_BUY && OrderType() != OP_SELL ) ) continue;  
         else { CountOrders++; TicketNumber = OrderTicket(); }
      }   
   //
   // This only works with zero or one position(s) per market symbol
   //
   if ( CountOrders != 1 ) 
      {
      Alert ("Count of orders for ",Symbol()," was ",CountOrders,", not 1. No action taken.");
      return(0);
      }
      
   //
   // One position found.
   //
   if (OrderSelect (TicketNumber, SELECT_BY_TICKET, MODE_TRADES) ) // if the order is chosen
      {
      NumberLots = OrderLots();
      if ( OrderType() == OP_SELL )
         {
         if ( OrderClose(OrderTicket(), OrderLots(), , Slippage, Green) )
            {
            Print( "Closed Sell Order" );
            if ( OrderSend( Symbol(), OP_BUY, NumberLots, Ask, Slippage, 0, 0, "Opened Buy Order", 0, 0, Orange ) > 0 )
               Print ( "Opened Buy Order at ", Ask );
            else 
               Alert ( "Could not open Buy order for ", Symbol(), " ", NumberLots, " at ", Ask, " Error=", GetLastError() );
            }
         else
            Alert ( "Could not close Sell order ",OrderTicket()," for ", Symbol(), " ", NumberLots, " at ", Ask, " Error=", GetLastError() );
         }
      else // OrderType() == OP_BUY )
         {
         if ( OrderClose(OrderTicket(), OrderLots(), , Slippage, Blue) )
            {
            Print("Closed Buy Order");  
            if ( OrderSend( Symbol(), OP_SELL, NumberLots, Bid, Slippage, 0, 0, "Opened Buy Order", 0, 0, Yellow ) > 0 )
               Print ( "Opened Buy Order at ",Bid );
            else 
               Alert ( "Could not open Sell order for ", Symbol(), " ", NumberLots, " at ", Bid, " Error=", GetLastError() );
            }
         else
            Alert ( "Could not close Buy order ",OrderTicket()," for ", Symbol(), " ", NumberLots, " at ", Bid, " Error=", GetLastError() );
         }
      }
   return(0);
   }

//  end of source